﻿Public Class Form1
  Dim ht As New Hashtable

  Private Sub NewAccount_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles NewAccount.Click
    Dim sa As SavingAccount
    Try
      sa = New SavingAccount(NameText.Text, _
        changeNumeric(NewAmountText.Text))
    Catch ex As ApplicationException
      MessageBox.Show(ex.Message)
      Exit Sub
    End Try
    ht.Add(sa.getAccountNo, sa)
    NewAccountLabel.Text = sa.getAccountNo()
    MessageBox.Show("口座を開設しました。")
  End Sub

  Public Function changeNumeric(ByVal _text As String) As Integer
    Dim num As Integer
    Try
      num = Integer.Parse(_text)
    Catch ex As FormatException
      Throw New System.ApplicationException("金額を正しく入力してください")
    End Try
    Return num
  End Function

  Private Sub DisplayAccount_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles DisplayAccount.Click

    Dim str As String = ""
    For Each de As DictionaryEntry In ht
      str = str & "口座番号：" & de.Value.getAccountNo() & vbTab & _
        "名前：" & de.Value.getName() & vbCrLf
    Next
    MessageBox.Show(str)
  End Sub

  Private Sub Deposit_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles Deposit.Click

    Dim sa As SavingAccount
    Try
      sa = existAccount(AccountText.Text)
      sa.Deposit(changeNumeric(AmountText.Text))
    Catch ex As ApplicationException
      MessageBox.Show(ex.Message)
      Exit Sub
    End Try
    MessageBox.Show("残高は " & sa.getBalance & "円 です。")
  End Sub

  Public Function existAccount(ByVal _accountNo As String) As Object
    If ht.ContainsKey(_accountNo) = False Then
      Throw New System.ApplicationException("口座番号が間違っています！")
    End If
    Return ht(_accountNo)
  End Function

  Private Sub Withdraw_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles Withdraw.Click

    Dim sa As SavingAccount
    Try
      sa = existAccount(AccountText.Text)
      sa.Withdraw(changeNumeric(AmountText.Text))
    Catch ex As ApplicationException
      MessageBox.Show(ex.Message)
      Exit Sub
    End Try
    MessageBox.Show("残高は " & sa.getBalance & "円 です。")
  End Sub

  Private Sub SendMoney_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles SendMoney.Click

    Dim sa1 As SavingAccount, sa2 As SavingAccount
    Try
      sa1 = existAccount(AccountText.Text)
      sa2 = existAccount(ToAccountText.Text)
      sa1.SendMoney(changeNumeric(AmountText.Text), sa2)
    Catch ex As ApplicationException
      MessageBox.Show(ex.Message)
      Exit Sub
    End Try
    MessageBox.Show("口座番号 " & ToAccountText.Text & " に " & _
    AmountText.Text & "円 振り込みました。")
  End Sub

  Private Sub RefBalance_Click(ByVal sender As System.Object, _
    ByVal e As System.EventArgs) Handles RefBalance.Click

    Dim sa As SavingAccount
    Try
      sa = existAccount(AccountText.Text)
      MessageBox.Show("残高は " & sa.getBalance & "円 です。")
    Catch ex As ApplicationException
      MessageBox.Show(ex.Message)
    End Try
  End Sub
End Class
